* Pgm: EDI_MAKE.PRG
* By: Elaine Rosenthal \ Computer Consultant \ 904-877-7718
* Created on 3/24/93
* Purpose: Reads an EDI flat file and creates sales orders.
* Comment: Uses low level file commands.  I chose to use the flat file
*  converted in a variable length format (80 characters delimited with ") 
*  because the FEOF() command detects the end of file w/the variable length
*  format (it doesn't w/the fixed file format) and the FGETS() command
*  correctly reads in one record,.i.e. 80 characters, whereas the fixed
*  length format reads in a peculiar amount (perhaps 256 or 512?) with a
*  fixed length format.  During the STX conversion to
*  a flat file I designate the flat file as variable field length, 
*  delimited by ".
* NOTE: When the STX flat-file-layout show a fields as:
*  R, make 'Number',10,0
*  NO, make 'Number',12,2
*  N2, make 'Number',11,2
**************************************************************************
CLEAR
CLOSE ALL  && CLOSE DATA won't close files open with FOPEN()
SET PROC TO agoutput
interupt = .F.
SET ESCAPE ON
ON ESCAPE interupt = .T.
SET UDFPARMS TO REFERENCE
RELEASE ALL LIKE m.*
DO input_scr WITH 'Create Temporary Database from EDI Flat File'

IF FILE('DX-XF-VV.080')  && make sure EDI flat file exists
   handle = FOPEN('DX-XF-VV.080',10)  && open as read only
ENDIF
IF handle < 0  && problem w/opening file (errfile = -1)
   WAIT 'Cannot open DX-XF-VV.080' WINDOW NOWAIT
   CLEAR
   RETURN
ENDIF   

* select databases
IF !USED('AGREPS')
   SELECT 0
   DO netopen WITH datapath+"AGREPS","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agreps
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agreps ORDER TAG rerep

IF !USED('AGTABLES')
   SELECT 0
   DO netopen WITH datapath+"AGTABLES","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agtables
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agtables ORDER TAG tab_cust

IF !USED('AGSCHED')
   SELECT 0
   DO netopen WITH datapath+"AGSCHED","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agsched
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agsched ORDER TAG schedule

IF !USED('AGPROD')
   SELECT 0
   DO netopen WITH datapath+"AGPROD","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agprod
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agprod

IF !USED('AGMASTER')  && customer database
   SELECT 0
   DO netopen WITH datapath+"AGMASTER","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agmaster
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agmaster ORDER TAG maname   

IF !USED('AGSALES')
   SELECT 0
   DO netopen WITH datapath+"AGSALES","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agsales
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO agsales ORDER TAG saponum  && to check for duplicate po#s

IF !USED('AGCUST')  && store database
   SELECT 0
   DO netopen WITH datapath+"AGCUST","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT agcust
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO &datapath.agcust ORDER TAG cuname

IF !USED('EDI_TABL')  && table of where in flat file data is stored
   SELECT 0
   DO netopen WITH datapath+"edi_tabl","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT edi_tabl
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO edi_tabl ORDER TAG edi_tabl

IF FILE(datapath+'AG_EDI.DBF')
   SELECT 0
   DO netopen WITH datapath+'AG_EDI','SHARED'
   IF !success
      RETURN
   ENDIF
   SET INDEX TO ag_edi ORDER TAG sainv  && must have to get index to work
   LOCATE FOR !DELETED()
   IF !EOF()
      DEFINE WINDOW mess_win FROM 10,6 TO 14,74 DOUBLE SHADOW COLOR SCHEME 5
      ACTIVATE WINDOW mess_win
      action = 'Append to it'
      @ 1,1 SAY "EDI sales orders file not empty. "GET action;
       FUNCTION '*H \!\?\<Append to it;\<Overwrite it' SIZE 1,6,3
      READ
      DEACTIVATE WINDOW mess_win
      IF READKEY() = 12 OR READKEY() = 268
         USE
         RETURN
      ENDIF
      IF action = 'Overwrite it'
         * close, then open in exclusive mode
         USE
         SELECT 0
         DO netopen WITH datapath+'AG_EDI','EXCLUSIVE'
		 IF !success
		    RETURN
	     ENDIF
         SET SAFETY OFF
         DELETE TAG ALL
         ZAP
         INDEX ON sainv TAG sainv OF ag_edi
         INDEX ON saponum TAG saponum of ag_edi
         INDEX ON saname TAG saname OF ag_edi
         INDEX ON DTOS(saentry) TAG saentry OF ag_edi
         INDEX ON DTOS(sareq) TAG sareq OF ag_edi
         INDEX ON DTOS(sabol) TAG sabol OF ag_edi
         INDEX ON sarep TAG sarep OF ag_edi
         INDEX ON samgr TAG samgr OF ag_edi
         INDEX ON sacust TAG sacust OF ag_edi
         SET SAFETY ON
         USE   && because it's currently open in exclusive mode
      ENDIF   
   ENDIF   
ELSE
   SELECT agsales
   COPY STRU TO &datapath.AG_EDI CDX
ENDIF   

IF !USED('AG_EDI')
   SELECT 0
   DO netopen WITH datapath+"AG_EDI","SHARED"
   IF !success
      RETURN
   ENDIF
ELSE
   SELECT ag_edi
   IF LEN(RELATION(1)) > 0
      SET RELATION TO
   ENDIF
ENDIF
SET INDEX TO ag_edi ORDER TAG sainv  && must have to get index to work

* initialize variables
title1 = 'Convert EDI Flat File into Sales Orders'
STORE '' TO title2,colhead1,colhead2

* select ouput device
pdevice = "      "
STORE 0 TO possible, ppage, line
DO getdvice WITH pdevice, possible    
IF READKEY() = 12
   RETURN
ENDIF
DO nxtline WITH 99
IF UPPER(pdevice) # 'SCREEN'
   SET DEVICE TO SCREEN
   DEFINE WINDOW mess_win FROM 11,27 TO 13,57 DOUBLE SHADOW COLOR SCHEME 5
   ACTIVATE WINDOW mess_win
   @ 0,1 SAY "Orders processed:"
   SET DEVICE TO PRINT
ENDIF
counter = 0   && counter
re_do = .F.

DO WHILE !FEOF(handle) AND !interupt
   IF !re_do
      text = FGETS(handle)
      text = TRIM(text)
   ENDIF
   re_do = .F.
   IF SUBSTR(text,1,2) = '//'  && header record
      IF counter # 0  && save previous record before beginning next one
         DO err_check WITH items
         APPEND BLANK
         m.saentry = DATE()
         m.saby = 'ED'
         GATHER MEMVAR
      ENDIF
      IF UPPER(pdevice) # 'SCREEN'
         SET DEVICE TO SCREEN
         @ 0,19 SAY counter PICT '999'
         SET DEVICE TO PRINT
      ENDIF   
      ** Header record must contain 2 things to be able to process the
      **  order: 1) '850' in the first set of quotes; indicates a purchase
      **  order, and 2) a customer name for which Agri has set up an
      **  EDI specs table.
      STORE '' TO m.tablname,m.formtype
      num_quotes = OCCURS('"',text)
      IF num_quotes > 2   && tablename & trans type exist
         first = ATC('"',text,1)+1  && first character w/in quotes
         end_quote = ATC('"',text,2)  && position of end quotes
         m.formtype = ALLTRIM(SUBSTR(text,first,end_quote-first))
         first = ATC('"',text,2)+1  && first character w/in quotes
         end_quote = ATC('"',text,3)  && position of end quotes
         m.tablname = ALLTRIM(SUBSTR(text,first,end_quote-first))
         m.tablname = IIF(LEN(m.tablname)>12,SUBSTR(m.tablname,1,2),;
          m.tablname)
         m.tablname = IIF(LEN(m.tablname)<12,;
          m.tablname+SPACE(12-LEN(m.tablname)),m.tablname)
      ENDIF
      SET EXACT OFF
      IF num_quotes < 3 OR m.formtype # '850' OR !SEEK(m.tablname,'EDI_TABL')
         DO CASE
            CASE num_quotes < 3
               ?? CHR(7)
               WAIT 'Table name &/or transaction type (850) missing from header.';
                WINDOW
            CASE m.formtype # '850'  && not a purchase order
               ?? CHR(7)
               WAIT 'Flat file form type is '+m.formtype+'.  Should be 850.';
                WINDOW
            CASE !SEEK(m.tablname,'EDI_TABL')
               ?? CHR(7)
               WAIT "You haven't set up an EDI specs table for "+m.tablname;
                +'.' WINDOW
         ENDCASE    
         text = FGETS(handle)
         text = TRIM(text)
         DO WHILE !FEOF(handle) AND !interupt AND SUBSTR(text,1,2) # '//'
            text = FGETS(handle)
            text = TRIM(text)
         ENDDO
         IF FEOF(handle) OR interupt
            EXIT
         ENDIF
         re_do = .T.
         SET EXACT ON
         LOOP
      ENDIF         
      SET EXACT ON
      counter = counter + 1   
      items = 0  && items ordered on the po
      total_sent = .F.  && was the total sent
      STORE '' TO m.maname,m.maaddr1,m.maaddr2,m.macity,m.mazip
      STORE '' TO m.cuname,m.cuaddr1,m.cuaddr2,m.cucity,m.cuzip
      SCATTER MEMVAR BLANK  && sales order fields
      LOOP
   ENDIF    

   * Read through the records in the flat file purchase order
   STORE 0 TO first,last 
   IF VAL(SUBSTR(text,1,2)) = 0  && 1st character wasn't a digit or blank
      WAIT "Character 1 of the flat file record # isn't a digit or blank.";
       WINDOW
      LOOP
   ENDIF          
   m.rec = VAL(SUBSTR(text,1,2))  && strip leading zero
   m.rec = STR(m.rec,2)  && convert to string of a true number
   * check to see if we have any need of data in this record number
   SET EXACT OFF
   IF !SEEK(m.tablname+m.rec,'EDI_TABL')
      SET EXACT ON
      LOOP
   ENDIF
   SET EXACT ON
   * The text string typically looks like this;
   *  03"BUILDERS SQUARE #1415"3316 SOUTH SHAVER
   * Thus the number of quotes indicates the number of pieces of info
   *  (excluding the record #) contained in the text.
   num_quotes = OCCURS('"',text)
   FOR quote_pos = 1 TO num_quotes
      m.pos = quote_pos + 1
      * Are we interested in this piece of info?
      IF !SEEK(m.tablname+m.rec+STR(m.pos,2),'EDI_TABL')
         LOOP
      ENDIF
      first = ATC('"',text,quote_pos)+1  && first character w/in quotes
      IF quote_pos # num_quotes
         end_quote = ATC('"',text,quote_pos+1)  && position of end quotes
         contents = SUBSTR(text,first,end_quote-first)
      ELSE
         contents = SUBSTR(text,first)
      ENDIF   
      IF EMPTY(contents)
         LOOP
      ENDIF   
      IF edi_tabl.type = 'DT'
         contents = SUBSTR(contents,3,2)+'/'+SUBSTR(contents,5,2)+'/'+;
          SUBSTR(contents,1,2)
         contents = CTOD(contents)
      ENDIF
      IF edi_tabl.type $ 'R | R|N0|N1|N2'
         contents = VAL(contents)
      ENDIF
      DO CASE
         CASE ALLTRIM(edi_tabl.descript) = 'PO #'
            m.saponum = contents
         CASE ALLTRIM(edi_tabl.descript) = 'Message'
            message = contents  && can be > 1 message per PO
            DO CASE
               CASE LEN(ALLTRIM(m.saspec1)) < 53  && field length 54
                  positn = IIF(EMPTY(m.saspec1),1,LEN(ALLTRIM(m.saspec1)) + 1)
                  sub_length = MIN(LEN(ALLTRIM(message)),55-positn)
                  m.saspec1 = ALLTRIM(m.saspec1)+SUBSTR(message,1,sub_length)
                  IF LEN(ALLTRIM(message)) > sub_length
                     m.saspec2 = SUBSTR(message,sub_length+1)
                  ENDIF
               CASE LEN(ALLTRIM(m.saspec2)) < 75
                  positn = IIF(EMPTY(m.saspec2),1,LEN(ALLTRIM(m.saspec2)) + 2)
                  sub_length = MIN(LEN(ALLTRIM(message)),77-positn)
                  m.saspec2 = IIF(EMPTY(m.saspec2),SUBSTR(message,1,sub_length),;
                  m.saspec2+' '+SUBSTR(message,1,sub_length))
                  IF LEN(ALLTRIM(message)) > sub_length
                     m.saspec3 = SUBSTR(message,sub_length+1)
                  ENDIF
               CASE LEN(ALLTRIM(m.saspec3)) < 75
                  positn = IIF(EMPTY(m.saspec3),1,LEN(ALLTRIM(m.saspec3)) + 2)
                  sub_length = MIN(LEN(ALLTRIM(message)),77-positn)
                  m.saspec3 = IIF(EMPTY(m.maspec3),SUBSTR(message,1,sub_length),;
                   m.maspec3 + ' ' + SUBSTR(message,1,sub_length))
            ENDCASE       
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To Name'
           * Lowe's send their name as "LOWE'S OF SW GREENSBORO, N. C." So
           * we set up the table to just the store number in the store name
           * field.  We have to strip leading zeros off the store number.
           IF m.tablname = 'LOWES'
              m.cuaddr1 = contents
              IF contents = 'LOWES N.WILKESBORO' OR contents = 'LOWES VILLA RICA'
                 m.saname = contents
              ENDIF   
           ELSE              
              IF ALLTRIM(contents) = 'H.Q. WAREHOUSE'
                 contents = 'HQ'
              ENDIF
              IF !EMPTY(m.saname)
                 m.saname = ALLTRIM(contents) + ALLTRIM(m.saname)
              ELSE
                 m.saname = contents
              ENDIF
              IF LEN(m.saname) > 16 
                 IF SUBSTR(m.saname,1,17) = 'BUILDERS SQUARE #'
                     m.saname = ALLTRIM('BUILDERS SQ ' + SUBSTR(m.saname,18))
                 ENDIF
              ENDIF
              IF LEN(ALLTRIM(m.saname))>18
                 saname_2 = SUBSTR(m.saname,19)
                 m.saname = SUBSTR(m.saname,1,18)
              ENDIF              
           ENDIF
        CASE ALLTRIM(edi_tabl.descript) = 'Store #'
           IF m.tablname = 'LOWES'  && have to strip off leading zeros
              cntr = 1
              DO WHILE cntr <= LEN(ALLTRIM(contents))
                 IF SUBSTR(contents,cntr,1) # '0'
                    contents = SUBSTR(contents,cntr)
                    EXIT
                 ELSE
                    cntr = cntr + 1
                 ENDIF
              ENDDO              
              m.saname = 'LOWES '
           ENDIF
           m.saname = m.saname + contents
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To Address'
           cuaddr = contents
           IF 'HQ' $ m.saname OR 'LOWES' $ m.saname
              m.cuaddr2 = cuaddr
           ELSE   
              m.cuaddr2 = IIF(LEN(ALLTRIM(cuaddr))>30,SUBSTR(cuaddr,31),'')
              m.cuaddr1 = SUBSTR(cuaddr,1,30)
           ENDIF
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To City'
           m.cucity = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To State'
           m.custate = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To Postal/Zip Code'
           m.cuzip = ALLTRIM(contents)
        CASE ALLTRIM(edi_tabl.descript) = 'Ship To Contact/Phone #'
           m.sacaller = ALLTRIM(contents)
           IF LEN(m.sacaller) > 12 AND '(' $ m.sacaller AND ')' $ m.sacaller AND '-' $ m.sacaller
               positn = 1
               DO WHILE .T.
                  IF !ISDIGIT(SUBSTR(m.sacaller,positn,positn))
                     DO CASE
                        CASE positn = 1 AND LEN(m.sacaller) = 1
                           m.sacaller = ''
                           EXIT
                        CASE positn = 1 AND LEN(m.sacaller) > 1
                           m.sacaller = SUBSTR(m.sacaller,2)
                        CASE positn > 1 AND positn < LEN(m.sacaller)
                           m.sacaller = SUBSTR(m.sacaller,1,positn-1)+;
                            SUBSTR(m.sacaller,positn+1)
                        CASE positn > 1 AND positn = LEN(m.sacaller)
                           m.sacaller = SUBSTR(m.sacaller,1,positn-1)
                           EXIT
                     ENDCASE
                     positn = 1
                  ELSE
                     positn = positn + 1
                     IF positn > LEN(m.sacaller)
                        EXIT
                     ENDIF   
                  ENDIF
               ENDDO
               IF LEN(m.sacaller) > 9
                  m.sacaller = SUBSTR(m.sacaller,1,3)+'-'+;
                   SUBSTR(m.sacaller,4,3)+'-'+SUBSTR(m.sacaller,7,4)
               ENDIF                
           ELSE                   
               m.sacaller = ALLTRIM(m.sacaller)
           ENDIF
           m.sacaller = IIF(LEN(m.sacaller)>12,SUBSTR(m.sacaller,1,2),m.sacaller)        
        CASE ALLTRIM(edi_tabl.descript) = 'Customer Name'
           m.maname = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Customer Address'           
           m.addr1 = contents
           m.maddr2 = IIF(LEN(ALLTRIM(m.maddr1))>30,SUBSTR(m.addr1,31),'')
           m.maddr1 = SUBSTR(m.maddr1,1,30)
        CASE ALLTRIM(edi_tabl.descript) = 'Customer City'           
           m.macity = contents
           m.macity2 = IIF(LEN(ALLTRIM(m.macity))>18,SUBSTR(m.macity,19),'')
           m.macity = SUBSTR(m.macity,1,18)
        CASE ALLTRIM(edi_tabl.descript) = 'Customer Postal/Zip Code'           
           m.mazip = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Request Date'
           m.sareq = contents
           * At Debbie's request on 5/18/93 ...
           m.sareq = IIF('BUILDERS SQ' $ m.saname,m.sareq - 7,m.sareq) 
        CASE ALLTRIM(edi_tabl.descript) = 'Quantity Ordered'
           items = items + 1
           PreQty = 'PreQty' + LTRIM(STR(items))           
           &PreQty = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Unit Price'
           * assign pre-conversion prices
           fld_name = 'PreEach' + LTRIM(STR(items))
           &fld_name = contents
        CASE ALLTRIM(edi_tabl.descript) = 'Product Code'
           * assign pre-translation product code
           fld_name = 'PreCode' + LTRIM(STR(items))
           &fld_name = ALLTRIM(contents)
        CASE ALLTRIM(edi_tabl.descript) = 'Total Amount'
           total_amt = contents
     ENDCASE     
   ENDFOR
ENDDO
IF !interupt
   IF counter > 0
      DO err_check WITH items
      APPEND BLANK
      m.saentry = DATE()
      m.saby = 'ED'
      GATHER MEMVAR
   ENDIF
   DO nxtline WITH 1
   @ line,0 SAY LTRIM(STR(counter)) + ' Records'
   IF UPPER(PDEVICE) # 'SCREEN'
      SET DEVICE TO SCREEN
      @ 0,19 SAY counter PICT '9999'
      EJECT 
   ELSE
      DO nxtline WITH 999
   ENDIF      
ELSE
   @ line,0 SAY "*** INTERRUPTED ***"
   IF UPPER(PDEVICE()) # 'SCREEN'
      EJECT
      SET DEVICE TO SCREEN
   ENDIF
ENDIF        
DEACTIVATE WINDOW mess_win
USE  && no need to keep ag_edi open
RETURN
   
*** error checking
PROC err_check
PARAMETER items
problems = .F.
IF SEEK(m.saponum,'AGSALES')
   SELECT agsales
   DO WHILE !EOF() AND saponum = m.saponum
      IF saname = m.saname
         DO print_num WITH problems,m.saname,m.saponum
         @ line,0 SAY 'Duplicate PO #'+TRIM(m.saponum)+' for '+TRIM(m.saname)+'.'
         DO nxtline WITH 1
         EXIT
      ENDIF   
      SKIP
   ENDDO
   SELECT ag_edi
ENDIF      
IF EMPTY(m.sareq)
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY 'No PO Date/Request Date.'
   DO nxtline WITH 1
ENDIF   
IF EMPTY(m.saname)
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY 'Store name was not sent.'
   DO nxtline WITH 1
   @ line,2 SAY 'Unable to write cust code/sales rep/manager/shipping pt into the order.'
   DO nxtline WITH 1
   @ line,2 SAY 'Unable to verify store address, products, or prices or get shipping pt.'
   DO nxtline WITH 1
ENDIF
IF !EMPTY(m.saname) AND !SEEK(m.saname,'AGCUST')  && verify store info
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY 'No store record for a store named ' + m.saname
   DO nxtline WITH 1
   @ line,2 SAY 'Unable to write cust code/sales rep/manager/shipping pt into the order.'
   DO nxtline WITH 1
   @ line,2 SAY 'Unable to verify store address and po#, or convert prices & product codes.'
   DO nxtline WITH 1
ELSE
   * get sales rep, cust code, mgr code, shipping pt
   m.sacust = agcust.cucust
   m.sarep = agcust.cuperson
   m.samgr = agcust.cumgr
   m.saship = agcust.cuship
   m.saccomm = agcust.cunotes
   IF (m.cuaddr1 # agcust.cuaddr1 AND !EMPTY(m.cuaddr1)) OR m.cuaddr2 #;
    agcust.cuaddr2 OR m.cucity # agcust.cucity OR m.cuzip #;
    ALLTRIM(agcust.cuzip) OR  m.custate # agcust.custate
      DO print_num WITH problems,m.saname,m.saponum
      @ line,0 SAY "Store address doesn't match address in store database."
      DO nxtline WITH 1
      @ line,2 SAY "Their's: " + m.cuaddr1
      @ line,43 SAY "Our's: " + agcust.cuaddr1
      DO nxtline WITH 1
      IF !EMPTY(m.cuaddr2) OR !EMPTY(agcust.cuaddr2)
         @ line,11 SAY m.cuaddr2
         @ line,50 SAY agcust.cuaddr2
         DO nxtline WITH 1
      ENDIF
      @ line,11 SAY m.cucity + ', ' + m.custate
      @ line,50 SAY ALLTRIM(agcust.cucity)+', '+agcust.custate
      DO nxtline WITH 1
      @ line,11 SAY m.cuzip
      @ line,50 SAY agcust.cuzip
      DO nxtline WITH 1  
   ENDIF
ENDIF   
IF !EMPTY(m.maname)
   IF !SEEK(m.maname,'AGMASTER')  && verify customer info
      DO print_num WITH problems,m.saname,m.saponum
      @ line,0 SAY 'No customer record for a customer named ' + m.maname
      DO nxtline WITH 1
      @ line,2 SAY 'Unable to verify customer address.'
   ELSE
      IF m.maaddr1 # agmaster.maaddr1 OR m.maaddr2 # agmaster.maaddr2 OR;
       m.macity # agmaster.macity OR m.mazip # ALLTRIM(agmaster.mazip)
         DO print_num WITH problems,m.saname,m.saponum
         @ line,0 SAY "Customer address doesn't match address in store database."
         DO nxtline WITH 1
         @ line,2 SAY "Their's: " + maaddr1
         @ line,43 SAY "Our's: " + agmaster.maaddr1
         DO nxtline WITH 1
         IF !EMPTY(m.maaddr2) OR !EMPTY(agmaster.maaddr2) 
            @ line,11 SAY m.maaddr2
            @ line,50 SAY agmaster.maaddr2
            DO nxtline WITH 1
         ENDIF
         @ line,11 SAY m.macity
         @ line,50 SAY agmaster.macity
         DO nxtline WITH 1
         @ line,11 SAY m.mazip
         @ line,50 SAY agmaster.mazip
         DO nxtline WITH 1  
      ENDIF
   ENDIF      
ENDIF
STORE .T. TO schedule,translatn
IF EMPTY(m.saname) OR EOF('AGCUST')  && can't get schedule name to verify product info
   schedule = .F.
   RETURN
ENDIF   
IF EMPTY(agcust.cutable)
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY "Product translation table name is missing from the store record."
   DO nxtline WITH 1
   @ line,2 SAY "Can't verify products & prices, or convert units (ex. gallons to cases)."
   DO nxtline WITH 1
   translatn = .F.
   RETURN
ENDIF
IF translatn AND !SEEK(agcust.cutable,'AGTABLES')
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY "Can't find product translation table " + ALLTRIM(agcust.cutable)+'.'
   DO nxtline WITH 1
   @ line,2 SAY "Can't verify products & prices, or convert units (ex. gallons to cases)."   
   DO nxtline WITH 1
   translatn = .F.
ENDIF
IF schedule AND !SEEK(agcust.cup_sch,'AGSCHED')
   DO print_num WITH problems,m.saname,m.saponum
   @ line,0 SAY "Can't find price schedule " + ALLTRIM(agcust.cup_sch)+'.'
   DO nxtline WITH 1
   @ line,2 SAY "Can't verify products & prices."   
   DO nxtline WITH 1
   schedule = .F.
ENDIF
IF !translatn
   RETURN
ENDIF   
ord_cntr = 1
DO WHILE ord_cntr <= items
   PreCode = 'PreCode' + LTRIM(STR(ord_cntr))
   PreEach = 'PreEach' + LTRIM(STR(ord_cntr))
   PreQty = 'PreQty' + LTRIM(STR(ord_cntr))
   IF EMPTY(&PreCode)
      ord_cntr = ord_cntr + 1
      LOOP
   ENDIF
   sch_cntr = 1
   IF !SEEK(agcust.cutable + &PreCode,'AGTABLES')
      DO print_num WITH problems,m.saname,m.saponum
      @ line,0 SAY 'Unable to find product ' + &PreCode +;
       ' in product translation table ' + agcust.cutable
      DO nxtline WITH 1
      @ line,2 SAY "Can't verify price, or convert units (ex. gallons to cases)."
      DO nxtline WITH 1
      ord_cntr = ord_cntr + 1
      LOOP 
   ENDIF    
   sacode = 'M.SACODE'+LTRIM(STR(ord_cntr))
   &sacode = agtables.code
   sch_cntr = 1    
   DO WHILE sch_cntr <= 38
      sch_code = 'agsched.code' + LTRIM(STR(sch_cntr))
      IF EMPTY(&sch_code)
         sch_cntr = sch_cntr + 1
         LOOP
      ENDIF
      IF &sch_code # &sacode
         sch_cntr = sch_cntr + 1
         LOOP
      ENDIF
      * found match in price schedule
      IF !SEEK(&sacode,'AGPROD')
         DO print_num WITH problems,m.saname,m.saponum
         @ line,0 SAY 'Unable to find ' + &sacode + ' from schedule ';
          + agsched.schedule + ' in Products database.'
         DO nxtline WITH 1
         @ line,2 SAY "Don't know whether to store "+LTRIM(STR(&PreQty))+ " units as Pallets, Cases, or Other."
         DO nxtline WITH 1
         @ line,2 SAY "Can't verify price.  Price: "
         @ line,29 SAY &PreEach PICT '99999.99'
         DO nxtline WITH 1
         EXIT            
      ENDIF
      fld_name = 'M.SADESC' + LTRIM(STR(ord_cntr))
      &fld_name = agprod.prdesc
      IF agprod.prby = 'B'  && bags = cases in EZDeck
         * Because Builder's Square orders in gallons but EZDeck records in
         *  cases, if product rec indicates B (=cases) must divide order
         *  by and multiply price by 6.
         IF MOD(&PreQty,6) # 0
            DO print_num WITH problems,m.saname,m.saponum
            @ line,0 SAY 'Remainder results when dividing units ordered by 6 to get cases.'
            DO nxtline WITH 1
            @ line,2 SAY 'Product: ' + LTRIM(STR(&sacode))
            @ line,19 SAY 'Units ordered: '
            @ line,34 SAY &PreQty PICT '99999'
            @ line,41 SAY 'Converted to cases:'
            @ line,61 SAY INT(&PreQty/6) PICT '99999'
            @ line,68 SAY 'Remainder: '
            @ line,79 SAY MOD(&PreQty,6) PICT '9'
            DO nxtline WITH 1
         ENDIF   
         qty = 'M.SABAGS' + LTRIM(STR(ord_cntr))
         &qty = INT(&PreQty / 6)
         saeach = 'M.SAEACH' + LTRIM(STR(ord_cntr))
         &saeach = &PreEach * 6
      ELSE
         IF agprod.prby = 'P'
            qty = 'M.SAPALL' + LTRIM(STR(ord_cntr))
            &qty = &PreQty
            saeach = 'M.SAEACH' + LTRIM(STR(ord_cntr))
            &saeach = &PreEach
            m.saptotal = m.saptotal + &PreQty
         ELSE  && 'other' order
            qty = 'M.SAOTH' + LTRIM(STR(ord_cntr))
            &qty = &PreQty
            saeach = 'M.SAEACH' + LTRIM(STR(ord_cntr))
            &saeach = &PreEach
         ENDIF
      ENDIF      
      each = 'agsched.each' + LTRIM(STR(sch_cntr))
      IF &each # &saeach
         DO print_num WITH problems,m.saname,m.saponum
         @ line,0 SAY 'Difference in Price for product '+LTRIM(STR(&sacode))
         @ line,43 SAY "Their's: " + LTRIM(STR(&saeach,7,2))
         @ line,64 SAY "Our's: " + LTRIM(STR(&each,7,2))
         DO nxtline WITH 1
      ENDIF   
      m.sadtotal = m.sadtotal + (&qty * &saeach)
      sch_cntr = sch_cntr + 1
   ENDDO   
   ord_cntr = ord_cntr + 1
ENDDO
IF total_sent
   IF TheirTotal # m.sadtotal
      DO print_num WITH problems,m.saname,m.saponum
      @ line,0 SAY 'Difference in totals'
      @ line,39 SAY "Their's: " + LTRIM(STR(TheirTotal))
      @ line,48 SAY TheirTotal PICT '999,999.99'
      @ line,60 SAY 'Computed: '
      @ line,70 SAY m.sadtotal PICT '999,999.99'
      DO nxtline WITH 1
   ENDIF
ENDIF
RETURN   

* Print record # to accompany error message?
PROC print_num
PARAMETER problems,m.saname,m.saponum
IF !problems
   DO nxtline WITH 1
   @ line,0 SAY 'RECORD FOR '+TRIM(m.saname)+'   PO #'+TRIM(m.saponum);
    + '    ORDER ' + LTRIM(STR(counter))
   DO nxtline WITH 1
   problems = .T.
ENDIF   

